"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = iDOMMethod;

var _toReference = _interopRequireDefault(require("./ast/to-reference"));

var _moduleSource = _interopRequireDefault(require("./module-source"));

var _addImport = _interopRequireDefault(require("./add-import"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// Returns a reference to an iDOM method.
function iDOMMethod(method, plugin) {
  var importSource = (0, _moduleSource["default"])(plugin);

  if (importSource) {
    return (0, _addImport["default"])(plugin.file, importSource, method);
  }

  return (0, _toReference["default"])(method);
}