"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = injectJSXWrapper;

var _inject = _interopRequireDefault(require("../inject"));

var t = _interopRequireWildcard(require("@babel/types"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// Wraps a JSX element in a lazy evaluation struct, capturing the arguments
// that its attributes and children need to render.
// We identify the struct by the __jsxDOMWrapper property.
function jsxWrapperAST(plugin, ref) {
  var func = t.identifier("func");
  var args = t.identifier("args");
  /**
   * function _jsxWrapper(func, args) {
   *   return {
   *     __jsxDOMWrapper: true,
   *     func: func,
   *     args: args,
   *   };
   * }
   */

  return t.functionExpression(ref, [func, args], t.blockStatement([t.returnStatement(t.objectExpression([t.objectProperty(t.identifier("__jsxDOMWrapper"), t.booleanLiteral(true)), t.objectProperty(func, func), t.objectProperty(args, args)]))]));
}

function injectJSXWrapper(plugin) {
  return (0, _inject["default"])(plugin, "jsxWrapper", jsxWrapperAST);
}