"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = toString;

var t = _interopRequireWildcard(require("@babel/types"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// Helper to transform a literal into an string literal.
function toString(literal) {
  var restricted = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
  var string;

  if (literal.isStringLiteral() || literal.isTemplateLiteral()) {
    return literal.node;
  }

  if (literal.isIdentifier()) {
    string = literal.node.name;
  } else if (literal.isUnaryExpression({
    operator: "void"
  })) {
    string = "undefined";
  } else if (literal.isNullLiteral()) {
    string = "null";
  } else if (literal.isNumericLiteral() || literal.isBooleanLiteral()) {
    string = String(literal.node.value);
  }

  if (restricted && (string === "undefined" || string === "null" || string === "true" || string === "false")) {
    return;
  }

  return t.stringLiteral(string);
}